<template>
  <form class="form">
    <h1 class="form__header">Personal info</h1>
    <div class="form-input">
      <span class="form-input__label">First name</span>
      <input
          class="form-input__field"
          v-model="form.firstName"
          :class="{'_error': errors.firstName}"
      />
    </div>
    <div class="form-input">
      <span class="form-input__label">Last name</span>
      <input
          class="form-input__field"
          v-model="form.lastName"
          :class="{'_error': errors.lastName}"
      />
    </div>
    <div class="form-input">
      <span class="form-input__label">E-mail</span>
      <input
          class="form-input__field"
          type="email"
          v-model="form.email"
          :class="{'_error': errors.email}"
      />
    </div>
    <div class="form-input" v-for="phone in form.phones" :key="phone.id">
      <span class="form-input__label">Phone</span>
      <div class="flex items-center">
        <div class="form-input__group form-group flex items-center" :class="{'_error': errors.phones}"
        >
          <select
              class="form-group__select"
              v-model="phone.selectedType"
          >
            <option
                v-for="option in allPhoneOptions"
                :key="option.id"
                :disabled="isDisabled(option.id)"
                :value="option"
            > {{ option.name }}
            </option>
          </select>
          <input
              class="form-group__field"
              type="tel"
              v-model="phone.number"
              @change="savePhone($event, phone)"
              @input="handleUserInput($event, phone)"
          />
        </div>
        <button type="button" class="button _delete" @click="deletePhone(phone)" v-if="phonesNumber > 1">Delete
        </button>
      </div>
    </div>
    <button
        type="button"
        class="button _add"
        @click="addPhone"
        v-if="phonesNumber < 5"
    >Add phone
    </button>
    <button
        type="submit"
        @click.prevent="next"
        class="button _nav">Continue
    </button>
  </form>
</template>

<script lang="ts">
import {computed, defineComponent, ref} from 'vue';
import {ContactInfo, SelectedPhoneInfo, ContactInfoErrors} from "@/models/types"
import {useStore} from 'vuex'
import {useRouter} from 'vue-router'
import {preselectedPhone, handleUserInput, allPhoneOptions, validate} from '@/utils/index'


export default defineComponent({
  setup() {
    const {push} = useRouter()
    const store = useStore()

    const contactInfo = computed(() => store.getters.contactInfo)

    const form = ref<ContactInfo>({
      firstName: contactInfo.value.firstName,
      lastName: contactInfo.value.lastName,
      email: contactInfo.value.email,
      phones: [{...preselectedPhone}],
    })

    function isDisabled(id: number): boolean {
      return form.value.phones.some((phone: SelectedPhoneInfo) => phone.selectedType.id === id)
    }

    const availablePhoneOptions = computed(() =>
        allPhoneOptions.filter(phone => !form.value.phones.some(({selectedType}) => selectedType.id === phone.id))
    )

    const phonesNumber = computed(() => form.value.phones.length)

    function deletePhone(phone: SelectedPhoneInfo): void {
      const removed = form.value.phones.findIndex((item: SelectedPhoneInfo) => item.id === phone.id)
      if (removed) form.value.phones.splice(removed, 1)
    }

    function addPhone(): void {
      form.value.phones.push(
          {
            id: form.value.phones[form.value.phones.length - 1].id + 1,
            number: '',
            selectedType: availablePhoneOptions.value[0],
          } as SelectedPhoneInfo
      )
    }

    function savePhone(event: Event, phone: SelectedPhoneInfo): void {
      const target = event.target as HTMLInputElement
      phone.number = target.value
    }

    const errors = ref<ContactInfoErrors>({
      firstName: false,
      lastName: false,
      email: false,
      phones: false,
    })

    function next(): void {
      if (!validate(errors.value, form.value)) return
      store.dispatch('saveContactInfo', form.value)
      push({name: 'membership'})
    }

    return {
      form,
      savePhone,
      deletePhone,
      addPhone,
      isDisabled,
      allPhoneOptions,
      next,
      errors,
      handleUserInput,
      phonesNumber,
    }
  }
});
</script>
